{⨭ 2}
unit MOUSE;
interface
 var i:byte;
     mvis:boolean;
     function     DETECTMOUSE:boolean;
     procedure    MOUSEON;
     procedure    MOUSEOFF;
     procedure    SETMOUSE(x,y:word);
     procedure    GETMOUSE(var l,r:boolean;var x,y:word);
     procedure    XLIM(min,max:word);
     procedure    YLIM(min,max:word);
implementation
function DETECTMOUSE;
begin
 asm
     mov ax,0
     int 33h
     or ax,ax
     jz @not
     mov @result,1
     jmp @en
@not:mov @result,0
@en:
 end;
end;
procedure MOUSEON;assembler;
 asm
        mov ax,1
        mov mvis,1
        int 33h
 end;
procedure MOUSEOFF;assembler;
 asm
        mov ax,0
        mov mvis,0
        int 33h
 end;
procedure SETMOUSE;assembler;
asm
   mov  ax,4
   mov  cx,x
   mov  dx,y
   int  33h
end;
procedure GETMOUSE;assembler;
asm
        lds  si,l
        lds  di,r
        xor  al,al
        mov  [si],al
        mov  [di],al
        mov  ax,3
        int  33h
        test bx,1
        jz   @l0
        mov  al,1
        mov  [si],al
@l0:    test bx,2
        jz   @r0
        mov  al,1
        mov  [di],al
@r0:    lds  si,x
        mov  [si],cx
        lds  si,y
        mov  [si],dx
end;
procedure XLIM;assembler;
asm
   mov  ax,7
   mov  cx,min
   mov  dx,max
   int  33h
end;
procedure YLIM;assembler;
asm
   mov  ax,8
   mov  cx,min
   mov  dx,max
   int  33h
end;
END.
